#include <X11/Xlib.h>
#include <X11/keysym.h>

extern unsigned char LEFT,RIGHT,DOWN,LEFT_OLD,RIGHT_OLD,DOWN_OLD;
extern int GAME,PAUSE,GLIMIT,LEVEL,PANIC,SCORE;
extern int GLIMIT_BY_LEVEL[10];
extern int KBD_COUNT;

KeySym K_LEFT;
KeySym K_RIGHT;
KeySym K_DOWN;
KeySym K_ROTATE;
KeySym K_BOTTOM;
KeySym K_UP;

void ProcessKeyEvent(Display *disp,Window win,GC gc,XEvent *event,XFontStruct *font)
{
	unsigned char what=(event->type==KeyPress)?1:0;
	KeySym ks;

	ks=XLookupKeysym((XKeyEvent *)event,0);

	if (event->xkey.keycode == K_BOTTOM && what && GAME && !PAUSE)
	{
		rock_bottom(disp,win,gc,font);
		return;
	}

	if (event->xkey.keycode == K_ROTATE && what && GAME && !PAUSE)
	{
		rotate_piece(disp,win,gc);
		return;
	}

	if (event->xkey.keycode == K_UP && what && GAME && LEVEL < 9)
	{
		LEVEL++;
		GLIMIT=GLIMIT_BY_LEVEL[LEVEL];
		draw_level(disp,win,gc);
		return;
	}

	if (ks == XK_s && what && !GAME)
	{
		GAME=1;
		SCORE=0;
		LEVEL=0;
		GLIMIT=GLIMIT_BY_LEVEL[LEVEL];
		clear_board();
		NextPiece(disp,win,gc);
		Redraw(disp,win,gc);
		show_message(disp,win,gc,font,"Press 'S' to start game",0);
		return;
	}

	if (ks == XK_p && what && GAME)
	{
		PAUSE=1-PAUSE;
		if (PAUSE)
			show_message(disp,win,gc,font,"Paused. Press 'P' to resume",1); else
			show_message(disp,win,gc,font,"Paused. Press 'P' to resume",0);
		return;
	}

	if (ks == XK_q && what)
	{
		XCloseDisplay(disp);
		exit(0);
	}
}

void GetKeyboardState(Display *disp)
{
	char data[32];

	XQueryKeymap(disp,data);
	LEFT=(data[K_LEFT/8]>>(K_LEFT%8))&1;
	RIGHT=(data[K_RIGHT/8]>>(K_RIGHT%8))&1;
	DOWN=(data[K_DOWN/8]>>(K_DOWN%8))&1;
	if (DOWN || (LEFT && RIGHT)) { LEFT=0; RIGHT=0; }

	if (LEFT != LEFT_OLD || RIGHT != RIGHT_OLD || DOWN != DOWN_OLD) KBD_COUNT=0;
	LEFT_OLD=LEFT;
	RIGHT_OLD=RIGHT;
	DOWN_OLD=DOWN;
}
